﻿// ActionScript 3.0クラス定義ファイル: MyTimerInfo.as
package {
	public class MyTimerInfo {
		private var totalMilliseconds:Number;
		public function MyTimerInfo(nMilliseconds:Number=0) {
			totalMilliseconds = nMilliseconds;
		}
		public function get milliseconds():int {
			var nMilliseconds:int = totalMilliseconds%1000;
			return nMilliseconds;
		}
		public function get seconds():int {
			var nSeconds:int = Math.floor(totalMilliseconds/1000)%60;
			return nSeconds;
		}
		public function get minutes():int {
			var nMinutes:int = Math.floor(totalMilliseconds/1000/60)%60;
			return nMinutes;
		}
		public function get hours():int {
			var nHours:int = Math.floor(totalMilliseconds/1000/60/60);
			return nHours;
		}
		public function set milliseconds(nMilliseconds:int):void {
			setTime(hours, minutes, seconds, nMilliseconds);
		}
		public function set seconds(nSeconds:int):void {
			setTime(hours, minutes, nSeconds, milliseconds);
		}
		public function set minutes(nMinutes:int):void {
			setTime(hours, nMinutes, seconds, milliseconds);
		}
		public function set hours(nHours:int):void {
			setTime(nHours, minutes, seconds, milliseconds);
		}
		public function setTime(nHours:int=0, nMinutes:int=0, nSeconds:int=0, nMilliseconds:int=0):void {
			nMinutes = nHours*60+nMinutes;
			nSeconds = nMinutes*60+nSeconds;
			nMilliseconds = nSeconds*1000+nMilliseconds;
			totalMilliseconds = nMilliseconds;
		}
		public function toString():String {
			var time_str:String = 
			String(hours)+":"+String(minutes)+":"+String(seconds)+"."+String(milliseconds);
			return time_str;
		}
	}
}