﻿// ActionScript 3.0クラス定義ファイル: Point3D.as
package {
	import flash.geom.Matrix;
	import flash.geom.Point;
	public class Point3D {
		private var _x:Number;
		private var _y:Number;
		private var _z:Number;
		public function Point3D(nX:Number, nY:Number, nZ:Number) {
			x = nX;
			y = nY;
			z = nZ;
		}
		public function get x():Number {
			return _x;
		}
		public function set x(nX:Number) {
			_x = nX;
		}
		public function get y():Number {
			return _y;
		}
		public function set y(nY:Number) {
			_y = nY;
		}
		public function get z():Number {
			return _z;
		}
		public function set z(nZ:Number) {
			_z = nZ;
		}
		internal function rotate(nRadianX:Number, nRadianY:Number, nRadianZ:Number):void {
			var nX:Number = x;
			var nY:Number = y;
			var nZ:Number = z;
			// X軸で回転
			var matrixX:Matrix = new Matrix();
			matrixX.rotate(nRadianX);
			var pointX:Point = matrixX.transformPoint(new Point(nY, nZ));
			nY = pointX.x;
			nZ = pointX.y;
			// Y軸で回転
			var matrixY:Matrix = new Matrix();
			matrixY.rotate(nRadianY);
			var pointY:Point = matrixY.transformPoint(new Point(nZ, nX));
			nZ = pointY.x;
			nX = pointY.y;
			// Z軸で回転
			var matrixZ:Matrix = new Matrix();
			matrixZ.rotate(nRadianZ);
			var pointZ:Point = matrixZ.transformPoint(new Point(nX, nY));
			nX = pointZ.x;
			nY = pointZ.y;
			x = nX;
			y = nY;
			z = nZ;
		}

	}
}