﻿// ActionScript 3.0クラス定義ファイル: RotationEvent.as
package rotation{
	import flash.events.Event;
	import flash.geom.Point;
	public class RotationEvent extends Event {
		public static  const ROTATE:String = "rotate";
		public var speed:Number;
		public var altitude:Number;
		public var centerX:Number;
		public var centerY:Number;
		public var radiusX:Number;
		public var radiusY:Number;
		public function RotationEvent() {
			super(ROTATE);
		}
		public function setRotationInfo(mySpeed:Number, myAltitude:Number, center:Point, radius:Point):void {
			speed = mySpeed;
			altitude = myAltitude;
			centerX = center.x;
			centerY = center.y;
			radiusX = radius.x;
			radiusY = radius.y;
		}
		override public function clone():Event {  // オーバーライド
			var myEventObject:RotationEvent = new RotationEvent();
			var center:Point = new Point(centerX, centerY);
			var radius:Point = new Point(radiusX, radiusY);
			myEventObject.setRotationInfo(speed, altitude, center, radius);
			trace("called");  // 確認用
			return myEventObject;
		}
		override public function toString():String {  // オーバーライド
			var return_str:String = formatToString("RotationEvent", "type", "bubbles", "cancelable", "eventPhase", "speed", "altitude", "centerX", "centerY", "radiusX", "radiusY");
			return return_str;
		}
	}
}