﻿// ActionScript 3.0クラス定義ファイル: MathUtils.as
package {
	import flash.geom.Matrix;
	import flash.geom.Point;
	public class MathUtils {
		public function MathUtils() {
		}
		public static function transformPoints(nWidth:Number, nHeight:Number, point0:Point, point1:Point, point2:Point):Matrix {
			var myMatrix:Matrix = new Matrix();
			var point1_0:Point = point0.subtract(point1);
			var point1_2:Point = point2.subtract(point1);
			myMatrix.tx = point1.x;
			myMatrix.ty = point1.y;
			myMatrix.a = (point1_0.x)/nWidth;
			myMatrix.b = (point1_0.y)/nWidth;
			myMatrix.c = (point1_2.x)/nHeight;
			myMatrix.d = (point1_2.y)/nHeight;
			return myMatrix;
		}
	}
}