﻿// ActionScript 3.0クラス定義ファイル: Sprite3D.as
package {
	import flash.display.Sprite;
	import flash.geom.Matrix;
	import flash.geom.Point;
	public class Sprite3D extends Sprite {
		private var _vertex:Array;
		public function Sprite3D() {
		}
		public function get vertex():Array {
			return _vertex;
		}
		public function set vertex(vertex_array:Array):void {
			_vertex=vertex_array;
		}
		internal function transformSpritePoints(point0:Point, point1:Point, point2:Point):void {
			// 面が裏向きなら非表示/表向きであれば変換
			if (visible = isFront(point0, point1, point2)) {
				transform.matrix = new Matrix();
				var nWidth:Number = width;
				var nHeight:Number = height;
				transform.matrix = MathUtils.transformPoints(nWidth, nHeight, point0, point1, point2);
			}
		}
		internal function isFront(point0:Point, point1:Point, point2:Point):Boolean {
			var bResult:Boolean;
			var point0_1:Point = point1.subtract(point0);
			var point0_2:Point = point2.subtract(point0);
			var nX0_1:Number = point0_1.x;
			var nY0_1:Number = point0_1.y;
			var nX0_2:Number = point0_2.x;
			if (!nX0_1) {
				bResult = (nY0_1>0) == (nX0_2>0);
			} else {
				var nY0_2:Number = point0_2.y;
				if (!nX0_2) {
					bResult = (nY0_2>0) != (nX0_1>0);
					trace(bResult);
				} else {
					bResult = (nY0_1/nX0_1<nY0_2/nX0_2) == ((0<nX0_1) == (0>nX0_2));
				}
			}
			return bResult;
		}
	}
}